Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3490)
@@ -28,4 +28,5 @@
       INTEGER, POINTER, DIMENSION(:,:)   ::  nbmap
       REAL   , POINTER, DIMENSION(:,:)   ::  nbw
+      REAL   , POINTER, DIMENSION(:,:)   ::  nbd
       REAL   , POINTER, DIMENSION(:)     ::  flagu
       REAL   , POINTER, DIMENSION(:)     ::  flagv
@@ -73,9 +74,7 @@
    INTEGER, DIMENSION(jp_bdy) ::   nn_tra_dta      	    !: = 0 use the initial state as bdy dta ; 
                                                             !: = 1 read it in a NetCDF file
-   LOGICAL, DIMENSION(jp_bdy) ::   ln_tra_dmp
-   LOGICAL, DIMENSION(jp_bdy) ::   ln_dyn3d_dmp
-   REAL,    DIMENSION(jp_bdy) ::   rn_time_dmp
-   LOGICAL                    ::   ln_tra_dmp_tot
-   LOGICAL                    ::   ln_dyn3d_dmp_tot
+   LOGICAL, DIMENSION(jp_bdy) ::   ln_tra_dmp               !: =T Tracer damping
+   LOGICAL, DIMENSION(jp_bdy) ::   ln_dyn3d_dmp             !: =T Baroclinic velocity damping
+   REAL,    DIMENSION(jp_bdy) ::   rn_time_dmp              !: Damping time scale in days
 
 #if defined key_lim2
@@ -107,5 +106,6 @@
    INTEGER,  DIMENSION(jp_bdy)                     ::   nn_dta            !: =0 => *all* data is set to initial conditions
                                                                           !: =1 => some data to be read in from data files
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global        !: workspace for reading in global data arrays
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global        !: workspace for reading in global data arrays (unstr.  bdy)
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global2       !: workspace for reading in global data arrays (struct. bdy)
    TYPE(OBC_INDEX), DIMENSION(jp_bdy), TARGET      ::   idx_bdy           !: bdy indices (local process)
    TYPE(OBC_DATA) , DIMENSION(jp_bdy)              ::   dta_bdy           !: bdy external data (local process)
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3490)
@@ -192,5 +192,5 @@
             IF( PRESENT(jit) ) THEN
                ! Update barotropic boundary conditions only
-               ! jit is optional argument for fld_read and tide_update
+               ! jit is optional argument for fld_read and bdytide_update
                IF( nn_dyn2d(ib_bdy) .gt. 0 ) THEN
                   IF( nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
@@ -200,47 +200,47 @@
                   ENDIF
                   IF (nn_tra(ib_bdy).ne.4) THEN
-                   IF (nn_dyn2d_dta(ib_bdy).eq.1.or.nn_dyn2d_dta(ib_bdy).eq.3.or.(ln_full_vel_array(ib_bdy).and.nn_dyn3d_dta(ib_bdy).eq.1)) THEN
-                     ! For the runoff case, no need to update the forcing (already done in the baroclinic part)
-                     jend = nb_bdy_fld(ib_bdy)
-                     IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend - 2
-                     CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), jit=jit, time_offset=time_offset )
-                     IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend + 2
-                     ! If full velocities in boundary data then split into barotropic and baroclinic data
-                     IF( ln_full_vel_array(ib_bdy) .and.                                             &
-                    &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 .or. nn_dyn3d_dta(ib_bdy) .eq. 1 ) ) THEN
-                        igrd = 2                      ! zonal velocity
-                        dta_bdy(ib_bdy)%u2d(:) = 0.0
-                        DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                           ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                           ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                           DO ik = 1, jpkm1
-                              dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
-                    &                          + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                     IF (nn_dyn2d_dta(ib_bdy).eq.1.or.nn_dyn2d_dta(ib_bdy).eq.3.or.(ln_full_vel_array(ib_bdy).and.nn_dyn3d_dta(ib_bdy).eq.1)) THEN
+                        ! For the runoff case, no need to update the forcing (already done in the baroclinic part)
+                        jend = nb_bdy_fld(ib_bdy)
+                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend - 2
+                        CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), jit=jit, time_offset=time_offset )
+                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend + 2
+                        ! If full velocities in boundary data then split into barotropic and baroclinic data
+                        IF( ln_full_vel_array(ib_bdy) .and.                                             &
+                       &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 .or. nn_dyn3d_dta(ib_bdy) .eq. 1 ) ) THEN
+                           igrd = 2                      ! zonal velocity
+                           dta_bdy(ib_bdy)%u2d(:) = 0.0
+                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
+                       &                          + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                              END DO
+                              dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
+                              END DO
                            END DO
-                           dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
-                           DO ik = 1, jpkm1
-                              dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
+                           igrd = 3                      ! meridional velocity
+                           dta_bdy(ib_bdy)%v2d(:) = 0.0
+                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
+                       &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
+                              END DO
+                              dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
+                              END DO
                            END DO
-                        END DO
-                        igrd = 3                      ! meridional velocity
-                        dta_bdy(ib_bdy)%v2d(:) = 0.0
-                        DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                           ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                           ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                           DO ik = 1, jpkm1
-                              dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
-                    &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
-                           END DO
-                           dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
-                           DO ik = 1, jpkm1
-                              dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
-                           END DO
-                        END DO
-                     ENDIF                    
-                   ENDIF
-                   IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                      CALL tide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy),   & 
-                      &                 jit=jit, time_offset=time_offset )
-                   ENDIF
+                        ENDIF                    
+                     ENDIF
+                     IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
+                        CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy),   & 
+                          &                 jit=jit, time_offset=time_offset )
+                     ENDIF
                   ENDIF
                ENDIF
@@ -306,5 +306,5 @@
                   ENDIF
                   IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                     CALL tide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy), time_offset=time_offset )
+                     CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy), time_offset=time_offset )
                   ENDIF
                ENDIF
@@ -378,18 +378,12 @@
       ! Set nn_dta
       DO ib_bdy = 1, nb_bdy
-         IF (nn_dyn2d_dta(ib_bdy).eq.1.OR.nn_dyn2d_dta(ib_bdy).eq.3) nn_dta(ib_bdy) = 1
-         IF (nn_dyn3d_dta(ib_bdy).ge.1) nn_dta(ib_bdy) = 1
-         IF (nn_tra_dta  (ib_bdy).ge.1) nn_dta(ib_bdy) = 1
-#if defined key_lim2
-         IF (nn_ice_lim2_dta(ib_bdy).eq.1) nn_dta(ib_bdy) = 1
-#endif
-         IF (lwp) THEN
-            WRITE(numout,*) 'Bdy package number ',ib_bdy
-            IF (nn_dta(ib_bdy).eq.1) THEN
-               WRITE(numout,*) 'We use external data'
-            ELSE
-               WRITE(numout,*) 'We do not use external data'
-            ENDIF
-         ENDIF
+         nn_dta(ib_bdy) = MAX(  nn_dyn2d_dta(ib_bdy)       &
+                               ,nn_dyn3d_dta(ib_bdy)       &
+                               ,nn_tra_dta(ib_bdy)         &
+#if defined key_lim2
+                               ,nn_ice_lim2_dta(ib_bdy)    &
+#endif
+                              )
+         IF(nn_dta(ib_bdy) .gt. 1) nn_dta(ib_bdy) = 1
       END DO
 
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn3d.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn3d.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn3d.F90	(revision 3490)
@@ -14,4 +14,5 @@
    !!----------------------------------------------------------------------
    USE timing          ! Timing
+   USE wrk_nemo        ! Memory Allocation
    USE oce             ! ocean dynamics and tracers 
    USE dom_oce         ! ocean space and time domain
@@ -27,4 +28,6 @@
    PUBLIC   bdy_dyn3d_dmp ! routine called by step
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -222,4 +225,30 @@
       IF( nn_timing == 1 ) CALL timing_start('bdy_dyn3d_dmp')
       !
+      !-------------------------------------------------------
+      ! Remove barotropic part from before velocity
+      !-------------------------------------------------------
+      CALL wrk_alloc(jpi,jpj,pu2d,pv2d) 
+
+      pu2d(:,:) = 0.e0
+      pv2d(:,:) = 0.e0
+
+      DO jk = 1, jpkm1
+#if defined key_vvl
+         pu2d(:,:) = pu2d(:,:) + fse3u_b(:,:,jk)* ub(:,:,jk)   *umask(:,:,jk) 
+         pv2d(:,:) = pv2d(:,:) + fse3v_b(:,:,jk)* vb(:,:,jk)   *vmask(:,:,jk)
+#else
+         pu2d(:,:) = pu2d(:,:) + fse3u_0(:,:,jk) * ub(:,:,jk)  * umask(:,:,jk)
+         pv2d(:,:) = pv2d(:,:) + fse3v_0(:,:,jk) * vb(:,:,jk)  * vmask(:,:,jk)
+#endif
+      END DO
+
+      IF( lk_vvl ) THEN
+         pu2d(:,:) = pu2d(:,:) * umask(:,:,1) / ( hu_0(:,:) + sshu_b(:,:) + 1._wp - umask(:,:,1) )
+         pv2d(:,:) = pv2d(:,:) * vmask(:,:,1) / ( hv_0(:,:) + sshv_b(:,:) + 1._wp - vmask(:,:,1) )
+      ELSE
+         pu2d(:,:) = pv2d(:,:) * hur(:,:)
+         pv2d(:,:) = pu2d(:,:) * hvr(:,:)
+      ENDIF
+
       DO ib_bdy=1, nb_bdy
          IF ( ln_dyn3d_dmp(ib_bdy).and.nn_dyn3d(ib_bdy).gt.0 ) THEN
@@ -228,7 +257,7 @@
                ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
                ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-               zwgt = idx_bdy(ib_bdy)%nbw(jb,igrd) / ( rn_time_dmp(ib_bdy) * rday )
+               zwgt = idx_bdy(ib_bdy)%nbd(jb,igrd)
                DO jk = 1, jpkm1
-                  ua(ii,ij,jk) = ( ua(ii,ij,jk) + zwgt * ( dta_bdy(ib_bdy)%u3d(jb,jk) - ub(ii,ij,jk) ) ) * umask(ii,ij,jk)
+                  ua(ii,ij,jk) = ( ua(ii,ij,jk) + zwgt * ( dta_bdy(ib_bdy)%u3d(jb,jk) - ub(ii,ij,jk) + pu2d(ii,ij)) ) * umask(ii,ij,jk)
                END DO
             END DO
@@ -238,11 +267,13 @@
                ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
                ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-               zwgt = idx_bdy(ib_bdy)%nbw(jb,igrd) / ( rn_time_dmp(ib_bdy) * rday )
+               zwgt = idx_bdy(ib_bdy)%nbd(jb,igrd)
                DO jk = 1, jpkm1
-                  va(ii,ij,jk) = ( va(ii,ij,jk) + zwgt * ( dta_bdy(ib_bdy)%v3d(jb,jk) - vb(ii,ij,jk) ) ) * vmask(ii,ij,jk)
+                  va(ii,ij,jk) = ( va(ii,ij,jk) + zwgt * ( dta_bdy(ib_bdy)%v3d(jb,jk) - vb(ii,ij,jk) + pv2d(ii,ij)) ) * vmask(ii,ij,jk)
                END DO
             END DO
          ENDIF
       ENDDO
+      !
+      CALL wrk_dealloc(jpi,jpj,pu2d,pv2d) 
       !
       CALL lbc_lnk( ua, 'U', -1. )   ;   CALL lbc_lnk( va, 'V', -1. )   ! Boundary points should be updated
